﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

class Program
{
    static void Main(string[] args)
    {
        PreLambdaDelegate preLambda = new PreLambdaDelegate();
        int result1 = preLambda.InstantiateAndCallDelegate();
        Console.WriteLine("Pre Lambda Delegate Result  = " + result1);

        PostLambdaExpressionsDelegate postLambda = new PostLambdaExpressionsDelegate();
        int result2 = postLambda.InstantiateAndCall();
        Console.WriteLine("Post LambdaExpressions Delegate Result = " + result2);
    }
}

public class PreLambdaDelegate
{
    // declare the delegate
    delegate int CalculateSum(int inta, int intb);

    // Instantiate delegate and call (Invoke) the method that the delegate points to
    public int InstantiateAndCallDelegate()
    {
        CalculateSum calculateDelegateInstance = new CalculateSum(DoActualCalculation);
        return calculateDelegateInstance.Invoke(3, 5);       
    }

    private int DoActualCalculation(int int1, int int2)
    {
        return int1 + int2;
    }
}

public class PostLambdaExpressionsDelegate
{
    // declare delegate (this part is the same as PreLambdaWay)
    delegate int CalculateSum(int inta, int intb);

    // create instance and call delegate using an anonymous method
    public int InstantiateAndCall()
    {
        CalculateSum doCalc = (x, y) =>
        {
            return x + y;
        };
        return doCalc(5,6);
    }
 
}



